#include "usart.h"
#include <stdlib.h>
#include <stdarg.h>

uint8_t UART_RX_BUF[UART_RX_BUF_MAX];
uint8_t UART_RX_CNT = 0;

static void NVIC_Configuration(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;
  
  /* ǶжϿѡ */
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
  
  /* USARTΪжԴ */
  NVIC_InitStructure.NVIC_IRQChannel = DEBUG_USART_IRQ;
  /* ȼ*/
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  /* ȼ */
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  /* ʹж */
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  /* ʼNVIC */
  NVIC_Init(&NVIC_InitStructure);
}


void ini_USART()
{
    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;

    // 򿪴GPIOʱ
    DEBUG_USART_GPIO_APBxClkCmd(DEBUG_USART_GPIO_CLK, ENABLE);
    
    // 򿪴ʱ
    DEBUG_USART_APBxClkCmd(DEBUG_USART_CLK, ENABLE);
    
    // USART TxGPIOΪ츴ģʽ
    GPIO_InitStructure.GPIO_Pin = DEBUG_USART_TX_GPIO_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(DEBUG_USART_TX_GPIO_PORT, &GPIO_InitStructure);

    // USART RxGPIOΪģʽ
    GPIO_InitStructure.GPIO_Pin = DEBUG_USART_RX_GPIO_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(DEBUG_USART_RX_GPIO_PORT, &GPIO_InitStructure);
    
    // ôڵĹ
    // ò
    USART_InitStructure.USART_BaudRate = DEBUG_USART_BAUDRATE;
    //  ֳ
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    // ֹͣλ
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    // Уλ
    USART_InitStructure.USART_Parity = USART_Parity_No ;
    // Ӳ
    USART_InitStructure.USART_HardwareFlowControl = 
    USART_HardwareFlowControl_None;
    // ùģʽշһ
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
    // ɴڵĳʼ
    USART_Init(DEBUG_USARTx, &USART_InitStructure);
    
    // жȼ
    NVIC_Configuration();
    
    // ʹܴڽж
    USART_ITConfig(DEBUG_USARTx, USART_IT_RXNE, ENABLE);	
    
    // ʹܴ
    USART_Cmd(DEBUG_USARTx, ENABLE);
}

//ֽ
void Usart_SendChar(USART_TypeDef* USARTx, uint8_t data)
{   //ȴɷд֮ǰԳôڷݵʱ
    while( USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET );
	USART_SendData(USARTx, data);
}

//ͱ
void Usart_Send(USART_TypeDef* USARTx,uint8_t* sh,uint8_t length)
{
    uint8_t cnt;
    for(cnt = 0; cnt < length; cnt++)
    {
        //ȴɷд֮ǰԳôڷݵʱ
        while( USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET );
        USART_SendData(USARTx, *sh++);
    }
}

//ַ
void Usart_SendString(USART_TypeDef* USARTx,uint8_t* sh)
{
    while(*sh)
    {
        while( USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET );
        USART_SendData(USARTx, *sh++);
    }
//    while( USART_GetFlagStatus(USARTx, USART_FLAG_TC) == RESET );
}


/*
//ģprintf
char zh[] = "0123456789ABCDEF";

void IntToStr(USART_TypeDef* USARTx,int32_t x,uint8_t bit)
{
    //жϷ
    if(x<0)
    {
        x = 0 - x;
        Usart_SendChar(USARTx,'-');
    }
    
    //õݹ麯ת
    if( x )
    {
        IntToStr(USARTx,x/bit,bit);
        Usart_SendChar(USARTx,zh[x % bit]);
    }
}

void DouToStr(USART_TypeDef* USARTx,double x)
{
    double   temp = 0;
    uint32_t num_H,num_L;
    if(x == 0)
    {
        Usart_SendString(USARTx,"0.0");
    }
    
    //
    if(x<0)
    {
        x   = 0 - x;
        Usart_SendChar(USARTx,'-');
    }
    
    //
    num_H = (unsigned int)x;
    IntToStr(USARTx,num_H,10);
    
    Usart_SendChar(USARTx,'.');
    
    //С
    temp  = ( x - num_H ) * 1000;
    num_L = (unsigned int)temp;
    IntToStr(USARTx,num_L,10);
}

void USART_printf(USART_TypeDef* USARTx,uint8_t* str, ...)
{
    va_list va_ptr;
    int32_t j = 0;  //
    uint8_t* sh;    //ַ
    double   dou;   //渡
//    uint8_t  ch;    //ַ
    
    va_start(va_ptr,str);
    while(*str)
    {
        if(*str != '%')
        {
            Usart_SendChar(USARTx,*(str++));
        }else
        {
            switch(*(++str))
            {
                case '%':       //'%'
                    Usart_SendChar(USARTx,'%');
                    break;
                case 'b':       //
                    j  = va_arg(va_ptr,int);
                    IntToStr(USARTx,j,2);
                    break;
                case 'c':       //ַ    warning:̫С
//                    ch = va_arg(va_ptr,unsigned char);
//                    Usart_SendChar(USARTx,ch);
                    break;
                case 'd':
                case 'l':       //()
                    j  = va_arg(va_ptr,int);
                    IntToStr(USARTx,j,10);
                    break;
                case 'x':       //()(16)
                    j  = va_arg(va_ptr,int);
                    IntToStr(USARTx,j,16);
                    break;
                case 'o':       //()(8)
                    j  = va_arg(va_ptr,int);
                    IntToStr(USARTx,j,8);
                    break;
                case 'f':       //
                    dou = va_arg(va_ptr,double);
                    DouToStr(USARTx,dou);
                    break;
                case 's' :      //ַ
                    sh = va_arg(va_ptr,uint8_t *);
                    Usart_SendString(USARTx,sh);
                    break;
            }
            str++;
        }
    }
    va_end(va_ptr);
}
*/

int fputc(int ch, FILE *f)
{
		USART_SendData(printf_Usartx, (uint8_t) ch);
		while (USART_GetFlagStatus(printf_Usartx, USART_FLAG_TXE) == RESET);
		return (ch);            
}

int fgetc(FILE *f)
{
		while (USART_GetFlagStatus(scanf_USARTx, USART_FLAG_RXNE) == RESET);
		return (int)USART_ReceiveData(scanf_USARTx);
}


// жϷ
void DEBUG_USART_IRQHandler(void)
{
    if(USART_GetITStatus(DEBUG_USARTx,USART_IT_RXNE)!=RESET)
    {
        if(UART_RX_CNT >= UART_RX_BUF_MAX)
        {
            UART_RX_CNT = 0;
        }
        UART_RX_BUF[UART_RX_CNT] = USART_ReceiveData(DEBUG_USARTx);     //ݱ浽
        UART_RX_CNT ++;
    }	 
}


